#include <pthread.h>        /* for POSIX threads */
#include <stdio.h>      /* for printf() and fprintf() */
#include <sys/socket.h> /* for socket(), bind(), and connect() */
#include <arpa/inet.h>  /* for sockaddr_in and inet_ntoa() */
#include <stdlib.h>     /* for atoi() and exit() */
#include <string.h>     /* for memset() */
#include <unistd.h>     /* for close() */
#include <time.h>
#include <sys/types.h>
#include <sys/poll.h>
//#include "creg.h"

#include "newcamd.h"
#include "des.h"
#include "newcamd-client.h"

#define BTKvers		"Vers 1.5 - 09/12/2011"



void DieWithError(char *errorMessage);  /* Error handling function */
int CreateTCPServerSocket(unsigned short port); /* Create TCP server socket */
int AcceptTCPConnection(int servSock);  /* Accept TCP connection request */
int CreateUDPServerSocket(unsigned short port); /* Create TCP server socket */

void *ThreadMain(void *arg);            /* Main program of a  TCP thread */
void *ThreadUDP(void *arg);            /* Main program of a UDP thread */
void *ThreadTEL(void *arg);            /* Main program of a TELNET thread */
void *Srv_status(void *);		// Status thread


pthread_mutex_t usrmutex     = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t dcwmutex     = PTHREAD_MUTEX_INITIALIZER;			//DCWkeys mutex for ecmsend/zapcam			
pthread_mutex_t keymutex     = PTHREAD_MUTEX_INITIALIZER;			//ECM list mutex - dynamic
pthread_mutex_t mtxcrypt     = PTHREAD_MUTEX_INITIALIZER;			//btkcrypt  mutex
pthread_mutex_t nccmutex[20];

/* Structure of arguments to pass to client threads */

struct ThreadArgs
{
    int clntSock;                      /* Socket descriptor for client */
};


//userlist
struct userlist
{
char user[20];
char pass[20];
int  stat;
char ip[20];
bool ok;
pthread_t tid;
struct userlist *next;
};
struct userlist *users,*usr_temp,*usr_cur;	//username pass linked list


struct keysdb
{
char pces[18];
char keys[32];
unsigned short int ecmid;
unsigned short int ecmcrc;
};
struct keysdb keysDB[500];
int dbsize=0;


struct bisskeys
{
char pces[20];
char keys[33];
time_t zaman;
};
bisskeys 	bisslist[100];				// BISS & DCW list in dcwbiss.cfg
int		bisscnt=0;
bisskeys	dcwlist[100];				//DCWs from ecmsend/zapcam
int	 	dcwcnt=0;


struct duplicatekeys
{
char pces1[20];
char pces2[20];
int  delay;
};
duplicatekeys 	dupkeys[50];				//Duplicate keys
int		dupcnt=0;

struct PCESlist
{
char pces[20];
int  kart;
};
PCESlist	pcesacc[20];				//PCES ->Ecm block/allow
int		pcesacnt=0;

struct NCCs
{
char		confn[200];
unsigned  int 	sids[200];
unsigned  int 	chid[200];
int		provs[20];
int		caid;
int		prvcnt;
int		cidcnt;
int		sidcnt;
bool		active;
};
struct 	NCCs	Nlist[11];			//ncc liste
int	Ncnt=0;					//ncc count
newcamd_client	*Ncc[11];			//newcamd clients




int	dbg;						//DEBUG
bool	gizli=false;					// if encryption on off
int	maxc=10000;					// max client connection
int	conn=0;						// printf("Server DBG  : %d\n",dbg);active connection count
char	keyIV[17];
char	sport[6];
char	keyUDP[10];
char	keyTEL[20];					//telnet pass
int	telport=0;					//telnet port
int	telsock;					//telnet server port
char	uprovcaid[4196];
int	timeout=10000;
int	ECMcfg=1;					// ECM -  0:No ECM          1:Only server Hosted N: (Default)      2:All ECMs
char	Cver[10]={ 0 };						//Client version

//registor *regi;
//bool 	REG;


//================== btkcrypt  CRYPT  =====================
void btkcrypt (char* message, int msglen, char *keyiv )
{
pthread_mutex_lock( &mtxcrypt );

unsigned char crp[2048];
int	ib,jb,zb;
unsigned char 	rand1,rand2,rand3;
int randx;
char		*src;
unsigned char 	crkeys[8];
unsigned char 	*dst = crkeys;
unsigned char	*end = crkeys + sizeof(crkeys);
unsigned int 	tmpu;
						
src = keyiv;	//Convert hexchar array to  bytes
dst = crkeys;
end = crkeys + sizeof(crkeys);
while (dst < end && sscanf(src, "%2x", &tmpu) == 1)
	{
	*dst++ = tmpu;
	src += 2;
	}

memcpy(crp,message,msglen);

srand ( time(NULL) );
rand1 = rand() % 256;
rand2 = rand() % 256;
rand3 = rand2 & 0x7;

crp[msglen]=rand1;		// add rand1 to the end of crp
for (ib=0;ib<msglen;ib++) crp[ib]=crp[ib]^rand1;  //xor crp except rand1
for (ib=0;ib<msglen+1;ib++) 			 //rotate all using rand3
	crp[ib]=( ( crp[ib] >> rand3 ) | ( crp[ib] << (8-rand3) ) );
for (ib=0;ib<msglen+1;ib++) crp[ib]=crp[ib]^rand2;  //xor with rand2
crp[msglen+1]=rand2;
for (ib=0;ib<msglen+2;ib++)
	crp[ib]=crp[ib] ^ crkeys[ib % 8];
memcpy(message, crp,msglen+2);
pthread_mutex_unlock( &mtxcrypt );
}


//btk decrypt function
void btkdecrypt (char* message, int msglen, char *keyiv )
{
pthread_mutex_lock( &mtxcrypt );
unsigned char crp[2048];
int	ib,jb,zb;
unsigned char 	rand1,rand2,rand3;
int randx;
char		*src;
unsigned char 	crkeys[8];
unsigned char 	*dst = crkeys;
unsigned char	*end = crkeys + sizeof(crkeys);
unsigned int 	tmpu;
						
src = keyiv;	//Convert hexchar array to bytes
dst = crkeys;
end = crkeys + sizeof(crkeys);
while (dst < end && sscanf(src, "%2x", &tmpu) == 1)
	{
	*dst++ = tmpu;
	src += 2;
	}

memcpy(crp,message,msglen);
for (ib=0;ib<msglen;ib++)			//xor with keys
	crp[ib]=crp[ib] ^ crkeys[ib % 8];

rand2=crp[msglen-1];			// last char is rand
rand3=rand2 & 0x7;
for (ib=0;ib<msglen;ib++)		//xor with rand2
	crp[ib]=crp[ib]^rand2;
for (ib=0;ib<msglen;ib++) 		//rotate all using rand3
	crp[ib]=( ( crp[ib] << rand3 ) | ( crp[ib] >> (8-rand3) ) );
rand1=crp[msglen-2];
for (ib=0;ib<msglen-1;ib++)		//xor with rand2
	crp[ib]=crp[ib]^rand1;
crp[msglen-1]=0;
memcpy(message,crp,msglen-1);
pthread_mutex_unlock( &mtxcrypt );
}


//delspace
void delspace (char *Str1)
{
int Pntr = 0;
int Dest = 0;
while (Str1 [Pntr])
{
if (Str1 [Pntr] != ' ')
	Str1 [Dest++] = Str1 [Pntr];
Pntr++;
}
Str1 [Dest++] = 0;
}


///MAIN APPLICATION
int main(int argc, char *argv[])
{
int servSock;                    /* Socket descriptor for server */
int clntSock;                    /* Socket descriptor for client */
int udpsock;                    /* Socket descriptor for client */

unsigned short echoServPort;     /* Server port */
pthread_t TCP,UDP,NCD,TEL,STT;   /* Thread ID from pthread_create() */
struct ThreadArgs *threadArgs;   /* Pointer to argument structure for thread */
struct NcdArgs *ncdargs;	/* pointer to NCD args */
FILE * isrtDosya;				// users.txr
char tmpstr[200];				//temp string for users.txt
int  ic,j;
char 	srvpath[100];
char	tempchr[20];
char 	sidchr[4];


	//REG=false;
	dbg=0;
	
	//if (argc <2) { printf("Requires password to start.\n"); exit(1); }
	strcpy(tmpstr,"dcwserver.cfg\0");
 	if (argc >= 2) {
			if (!strncmp(argv[1],"-d",2)) dbg=1;
			if (!strncmp(argv[1],"-C",2)) { strcpy(tmpstr,argv[2]); strcat(tmpstr,"dcwserver.cfg\0"); }
			}

	
	printf("\n-------------Registered Version------------\n");
	printf("Using Config file : %s\n",tmpstr); 
	// parse config
	isrtDosya=fopen(tmpstr,"r");
	if (isrtDosya==NULL)
		{
		fprintf(stderr,"File missing : dcwserver.cfg\n", argv[0]);
        	exit(1);
		}
	usr_temp= (struct userlist *)malloc(sizeof(struct userlist));
	users=usr_temp;
	while ( fgets ( tmpstr, 200, isrtDosya ) != NULL )
		{
		if (strncmp(tmpstr,"Debug: ",7)==0) sscanf(tmpstr, "Debug: %d", &dbg);
		if (strncmp(tmpstr,"Port: ",6)==0) sscanf(tmpstr, "Port: %5s", sport);
		if (strncmp(tmpstr,"SKey: ",6)==0) 
			{
			sscanf(tmpstr, "SKey: %16s", keyIV);
			gizli=true;
			}
		if (strncmp(tmpstr,"Tcfg: ",6)==0) sscanf(tmpstr, "Tcfg: %d %s ", &telport, keyTEL);
		if (strncmp(tmpstr,"MaxC: ",6)==0) sscanf(tmpstr, "MaxC: %d", &maxc);	
		if (strncmp(tmpstr,"EcmC: ",6)==0) sscanf(tmpstr, "EcmC: %d", &ECMcfg);
		if (strncmp(tmpstr,"Tout: ",6)==0) sscanf(tmpstr, "Tout: %d", &timeout);	
		if (strncmp(tmpstr,"UKey: ",6)==0) sscanf(tmpstr, "UKey: %s", keyUDP);
		if (strncmp(tmpstr,"Cver: ",6)==0) sscanf(tmpstr, "Cver: %s", Cver);
		if (strncmp(tmpstr,"N: ",3)==0) 
			{ 
			memcpy(Nlist[Ncnt].confn,tmpstr,sizeof(tmpstr)); 
			Nlist[Ncnt].sidcnt=0;
			Nlist[Ncnt].cidcnt=0;
			Ncnt++; 
			}
		if (strncmp(tmpstr,"SID: ",5)==0) 
			{
			delspace(tmpstr);
			for (j=1;j<(strlen(tmpstr)/4);j++)
				{
				memcpy(sidchr,tmpstr+(j*4),4);
				sscanf(sidchr,"%4x",&Nlist[Ncnt-1].sids[j-1+Nlist[Ncnt-1].sidcnt]);
				}
			Nlist[Ncnt-1].sidcnt += j-1;
			}
		if (strncmp(tmpstr,"CID: ",5)==0) 
			{
			delspace(tmpstr);
			for (j=1;j<(strlen(tmpstr)/4);j++)
				{
				memcpy(sidchr,tmpstr+(j*4),4);
				sscanf(sidchr,"%4x",&Nlist[Ncnt-1].chid[j-1+Nlist[Ncnt-1].cidcnt]);
				}
			Nlist[Ncnt-1].cidcnt += j-1;
			}
		if (strncmp(tmpstr,"U: ",3)==0)
			{
			sscanf(tmpstr, "U: %15s %15s %d", usr_temp->user, usr_temp->pass, &usr_temp->stat);
			//if (!REG) usr_temp->stat=2;
			usr_temp->ok=false; memset(usr_temp->ip,0,sizeof(usr_temp->ip));
			usr_cur=usr_temp;
			usr_temp= (struct userlist *)malloc(sizeof(struct userlist));
			usr_cur->next=usr_temp;
			}
		if (strncmp(tmpstr,"DupCW: ",7)==0) 
			{ 
			sscanf(tmpstr, "DupCW: %s %s %d",dupkeys[dupcnt].pces1,dupkeys[dupcnt].pces2,&dupkeys[dupcnt].delay);
			memcpy(dcwlist[dupcnt].pces,dupkeys[dupcnt].pces2,18);
			dupcnt++; 
			dcwcnt++;					//Udp dcws after static dup dcws
			}
		if (strncmp(tmpstr,"PCES: ",6)==0) 
			{ 
			sscanf(tmpstr, "PCES: %s %d",pcesacc[pcesacnt].pces,&pcesacc[pcesacnt].kart);
			pcesacnt++; 
			}
		}
	usr_cur->next=NULL;
	free(usr_temp);
	fclose (isrtDosya);
	

	// parse dcw / biss
	if (argc ==4) { strcpy(tmpstr,argv[3]);strcat(tmpstr,"dcwbiss.cfg\0");  }
		else strcpy(tmpstr,"dcwbiss.cfg\0");
	isrtDosya=fopen(tmpstr,"r");
	if (isrtDosya!=NULL)
		{
		while ( fgets ( tmpstr, 200, isrtDosya ) != NULL )
		   if (strncmp(tmpstr,"DB: ",4)==0) 
			{
			sscanf(tmpstr, "DB: %12s %32s",bisslist[bisscnt].pces,bisslist[bisscnt].keys );
			bisscnt++;
			}
		fclose (isrtDosya);
		}

	//if (!REG) { printf("invalid licence.\n"); exit(1); }

	// Startup of config
	printf("\nStarting Dcwserver %s... by BillyTK\n",BTKvers);
	printf("Server Port : %s\n",sport);
	printf("Server Key  : %s\n",keyIV);
	printf("Server Tout : %d\n",timeout);
	printf("Server EcmC : %d\n",ECMcfg);
	printf("UDPsrv Key  : %s\n",keyUDP);
	printf("Telnet Cfg  : %d %s\n",telport,keyTEL);
	printf("Client Max  : %d\n",maxc);
	printf("Client Vers : %s\n",Cver);
	printf("Server DBG  : %d\n",dbg);

	// show users and BISS
	usr_temp=users;
	if (dbg) printf("---------Parsing Users-------\n");
	if (dbg) while (usr_temp!=NULL)
		{
		memset(tmpstr,0,sizeof(tmpstr));
		sprintf(tempchr,"%d",usr_temp->stat);
		strcpy(tmpstr,"User:                Pass:                Stat:      \0");
		memcpy(tmpstr+5,usr_temp->user,strlen(usr_temp->user));
		memcpy(tmpstr+10+16,usr_temp->pass,strlen(usr_temp->pass));
		memcpy(tmpstr+15+32,tempchr,strlen(tempchr));
		printf("%s\n",tmpstr);
		//printf("User/Pass/Stat: %s %s %d \n",usr_temp->user, usr_temp->pass, usr_temp->stat );
		usr_temp=usr_temp->next;
		} 
	if (dbg) printf("---------BISS Entries--------\n");
	if (dbg) for (ic=0;ic<bisscnt;ic++)
		printf("BISS %02d: %s:%s\n",ic+1,bisslist[ic].pces,bisslist[ic].keys);
	
	//if (!REG)
		if (Ncnt>10) Ncnt=10;
		

	// Create NCC clients
	memset(uprovcaid,0,sizeof(uprovcaid));
	for(int i=0;i<Ncnt;i++)
    		{
		printf("------------------------------------------\n");
		if (Ncc[i] = new newcamd_client(Nlist[i].confn,timeout,VERSION_525), !Ncc[i])
			{
			perror("NEWCAMD Server #%d  Init Failed ");
			return(0);
			}
		Ncc[i]->dbg=dbg;
		Nlist[i].active=false;
		Nlist[i].prvcnt=0;
		if (Ncc[i]->is_ready())
			{
			Nlist[i].active=true;
			Nlist[i].caid=Ncc[i]->card_caid;
			Nlist[i].prvcnt=Ncc[i]->card_provider_id_count;
			for (j=0 ;j<Ncc[i]->card_provider_id_count;j++)
				{
				sprintf(tempchr,"%06X",Ncc[i]->card_provider_id[j]);
				strcat(uprovcaid,tempchr);
				sprintf(tempchr,"%04X",Ncc[i]->card_caid);			//user login text provcaid
				strcat(uprovcaid,tempchr);
				Nlist[i].provs[j]=Ncc[i]->card_provider_id[j];
				}
			}
		
		
		if (Nlist[i].sidcnt>0) 
			{
			printf("Allowed (N) SIDS  : %d ",Nlist[i].sidcnt);
			for (j=0 ;j<Nlist[i].sidcnt;j++)
				printf("%04X ",Nlist[i].sids[j]);
			printf("\n");
			}
		if (Nlist[i].cidcnt>0) 
			{
			printf("Allowed (N) CHIDS : %d ",Nlist[i].cidcnt);
			for (j=0 ;j<Nlist[i].cidcnt;j++)
				printf("%04X ",Nlist[i].chid[j]);
			printf("\n");
			}
		}
	printf("%d Newcamd Clients Created.\n",Ncnt);

	// Create NCC mutexes
	for(int i=0;i<Ncnt;i++) pthread_mutex_init(&nccmutex[i], NULL);
	printf("%d Mutex init done.\n",Ncnt);

	///---------UDP thread activation---------------------
	echoServPort = atoi(sport);  
	udpsock = CreateUDPServerSocket(echoServPort);
        if ((threadArgs = (struct ThreadArgs *) malloc(sizeof(struct ThreadArgs)))== NULL)
         	DieWithError("malloc() failed");
        threadArgs -> clntSock = udpsock;
        if (pthread_create(&UDP, NULL, ThreadUDP, (void *) threadArgs) != 0)
        	DieWithError("pthread_create() failed");
	printf("UDPKey Server thread created.\n");

	//-------Telnet Thread activation----------
	if (telport!=0)
		{
		if (pthread_create(&TEL, NULL, ThreadTEL, NULL) != 0)
            		DieWithError("pthread_create() failed");Nlist[Ncnt].sidcnt=0;
		printf("Telnet Server thread created.\n");
		}

	//----------Create System Status Thread------------.  //restores down NCCs
	if (pthread_create(&STT, NULL, Srv_status, NULL) != 0) DieWithError("pthread_create() failed");
	printf("System Status Thread Created.\n-------------------------------\n",Ncnt);


    	//---------------TCP Client Thread creation in loop -----------------------
	servSock = CreateTCPServerSocket(echoServPort);

    	while (1) 
	  if (conn<maxc)
    		{
		clntSock = AcceptTCPConnection(servSock);

		pthread_mutex_lock( &usrmutex );
		conn++;						//increase connection count
		pthread_mutex_unlock( &usrmutex );
	
        	/* Create separate memory for client argument */
        	if ((threadArgs = (struct ThreadArgs *) malloc(sizeof(struct ThreadArgs))) == NULL)
        	 	DieWithError("malloc() failed");
        	threadArgs -> clntSock = clntSock;
        	/* Create client thread */
        	if (pthread_create(&TCP, NULL, ThreadMain, (void *) threadArgs) != 0)
            	DieWithError("pthread_create() failed");
    		}
    /* NOT REACHED */
}

void *ThreadMain(void *threadArgs)
{
	int clntSock;                   /* Socket descriptor for client connection */
	char echoBuffer[2048];          /* Buffer for echo string */
	int recvMsgSize;                    /* Size of received message */
	char cmd1[5];
	char cmd2[512];
	char cmdtmp[512];
	unsigned char ecmdata[512];
	int ecmlen;
	bool auth;
	bool keyok;
	struct userlist *srcuser;
	int j,m,nx;
	sockaddr_in claddr;
	socklen_t clen;
	char cl_ip[20];
	pthread_t thrid;

	unsigned short int irdchid;
	unsigned int	provx;
	unsigned int 	caidx;
	unsigned int	sidx;
	unsigned int 	pidx;
	unsigned int 	tidx;
	unsigned int 	crcx;
	unsigned int 	dbcur;

	char 		prov1[7];
	char 		caid1[5];
	char 		pid1[5];
	char 		sid1[5];
	char		tidc[2];		//char table id
	int		route;

	
	auth=false;
	thrid=pthread_self();
	/* Guarantees that thread resources are deallocated upon return */
	pthread_detach(pthread_self()); 
	/* Extract socket file descriptor from argument */
	clntSock = ((struct ThreadArgs *) threadArgs) -> clntSock;
	free(threadArgs);              /* Deallocate memory for argument */
	clen = sizeof(claddr);
	getpeername(clntSock, (sockaddr*)&claddr, &clen);
	strcpy(cl_ip,inet_ntoa(claddr.sin_addr));
	if (dbg) printf("Connection From     : %s\n",cl_ip);

	//send welcome message and start loop
	memset(echoBuffer,0,sizeof(echoBuffer));
	strcpy(echoBuffer,"Welcome to DcwServer by BillyTK\0\0");
	if (write(clntSock, echoBuffer, 32) != 32)  goto GEBER;

	/* Receive message from client for authtenication*/
	memset(echoBuffer,0,sizeof(echoBuffer));
	recvMsgSize = read(clntSock, echoBuffer, 1024);
	if ( recvMsgSize < 5) goto GEBER;
	if ( recvMsgSize > 60) goto GEBER;
	if (gizli) 
		{
		if (recvMsgSize < 9) goto GEBER;
		btkdecrypt(echoBuffer,recvMsgSize,keyIV);
		recvMsgSize -= 2;
		} 
	memset(cmd1,0,sizeof(cmd1));
	memset(cmd2,0,sizeof(cmd2));
	memcpy(cmd1,echoBuffer,4);
	memcpy(cmd2,echoBuffer+4,recvMsgSize-4);
	if (dbg) printf("Received Command:%s%s\n",cmd1,cmd2);
	if (strncmp(cmd1,"USER",4)==0)
		{
		pthread_mutex_lock( &usrmutex );
		srcuser=users;
		while ( (srcuser!=NULL) && (auth==false) )
			{
			memset(cmdtmp,0,sizeof(cmdtmp));
			strcpy(cmdtmp,srcuser->user);strcat(cmdtmp,srcuser->pass);
			//if (dbg) printf("Users ?? %s == %s\n",cmd2,cmdtmp);
			if ((strcmp(cmd2,cmdtmp)==0)  && (srcuser->stat!=0) ) auth=true;
			 else srcuser=srcuser->next;
			}
		pthread_mutex_unlock( &usrmutex );	
		if (!auth) goto GEBER;
		//printf("User pass are correct\n");
		memset(echoBuffer,0,sizeof(echoBuffer));
 		strcpy(echoBuffer,"ASK:");
		if (Cver==0) strcat(echoBuffer,"YES\0");  else strcat(echoBuffer,Cver); 	//response 
		if (ECMcfg==1) strcat(echoBuffer,uprovcaid);
		if (ECMcfg==2) strcat(echoBuffer,"FFFFFFFFFF\0");
		//printf("Echobuffer %d : %s\n",strlen(uprovcaid),echoBuffer);
		recvMsgSize=strlen(echoBuffer);
		if (gizli) 
			{
			btkcrypt(echoBuffer,recvMsgSize,keyIV);
			recvMsgSize += 2;
			}
		if (write(clntSock, echoBuffer,recvMsgSize ) != recvMsgSize )  goto GEBER;
		}
	if (auth)
		{
		pthread_mutex_lock( &usrmutex );
		srcuser->ok=true;
		strcpy(srcuser->ip,cl_ip);
		srcuser->tid=thrid;
		pthread_mutex_unlock( &usrmutex );
		if (dbg) printf ("User:%s  Pass:%s  IP:%s  TID:%ld\n",srcuser->user,srcuser->pass,srcuser->ip,(long int) srcuser->tid  );
		}
	//Start Loop after authentication
	while (auth)
		{
		/* Receive message from client  after authtenication*/
		memset(echoBuffer,0,sizeof(echoBuffer));
		if ((recvMsgSize = read(clntSock, echoBuffer, 300)) < 5) 
				{ 
				if (dbg) printf("Invalid message size : %d\n",recvMsgSize);
				goto GEBER;
				}
		
		if ( recvMsgSize > 299) 
				{ 
				if (dbg) printf("Invalid message size : %d\n",recvMsgSize);
				keyok=false;
				goto Defgo;
				}
		if (gizli) 
			{
			if (recvMsgSize < 7) goto GEBER;
			btkdecrypt(echoBuffer,recvMsgSize,keyIV);
			recvMsgSize -= 2;
			} 
		if (dbg) printf("-----------------------------------\n");
		memset(cmd1,0,sizeof(cmd1));
		memset(cmd2,0,sizeof(cmd2));
		memcpy(cmd1,echoBuffer,4);

		keyok=false;
		
		if (strncmp(cmd1,"ASK:",4)==0)
			{
			//if (dbg) printf("Searching Share Key : %s\n",cmd2);
			memcpy(cmd2,echoBuffer+4,recvMsgSize-4);
			if (dbg) printf("Received Command    : %s%s from %s %s\n",cmd1,cmd2,cl_ip,srcuser->user);
			if ( (bisscnt>0) && (cmd2[0]=='F') )
				{
				//if (dbg) printf("Searching BISS  Key : %s\n",cmd2);
				j=0;
				while ((!keyok) && (j<bisscnt))
				     if (strncmp(bisslist[j++].pces,cmd2,32)==0) keyok=true;
				if (keyok) {
					memset(echoBuffer,0,sizeof(echoBuffer));
					strcpy(echoBuffer,"KEY."); 
					strcat(echoBuffer,bisslist[j-1].keys);
					}
				}
			if ( (dcwcnt>0) && (cmd2[0]!='F') )
				{
				//if (dbg) printf("Searching DCW  Key : %s\n",cmd2);
				j=0;
				pthread_mutex_lock( &dcwmutex );
				while ((!keyok) && (j<dcwcnt))
				     if (memcmp(dcwlist[j++].pces+6,cmd2,12)==0) keyok=true;
				if (keyok) {
					memset(echoBuffer,0,sizeof(echoBuffer));
					strcpy(echoBuffer,"KEY:"); 
					strcat(echoBuffer,dcwlist[j-1].keys);
					}
				pthread_mutex_unlock( &dcwmutex );
				}
			}	
		
		if ( (strncmp(cmd1,"ECM:",4)==0) && (Ncnt>0) && (ECMcfg>0) ) 
			{
			memcpy(cmd2,echoBuffer+4,18);			//ECM: PROVID  CAID PID0 SID0 + ecmdata
			memcpy(ecmdata,echoBuffer+22,recvMsgSize-22);
			ecmlen=recvMsgSize-22;
			if (dbg) printf("Received Command    : %s%s from %s %s\n",cmd1,cmd2,cl_ip,srcuser->user);
			memcpy(prov1,cmd2+0,6 );
			memcpy(caid1,cmd2+6,4 );
			memcpy(pid1 ,cmd2+10,4 );
			memcpy(sid1 ,cmd2+14,4 );
			sscanf(prov1  , "%6X",&provx);
			sscanf(caid1  , "%4X",&caidx);
			sscanf(pid1   , "%4X",&pidx);
			sscanf(sid1   , "%4X",&sidx);
			
			if ((caidx==0x1833)) // || (caidx==0x1834))
				{
				if (dbg) printf("Beta tunnel : %04X\n",caidx);
				unsigned char hack[13]={0x70, 0x51, 0xc7, 0x00, 0x00, 0x00, 0x01, 0x10, 0x10, 0x00, 0x87, 0x12, 0x07};
				if (caidx==0x1833) caidx=0x1702; //else caidx==0x1722;
				provx=0;
				ecmlen+=13;
				int l;
				l=(ecmdata[2]+3);
				memmove(ecmdata+14, ecmdata+4, l-1);
				memcpy(ecmdata+1, hack, 13);
				l+=10;
				ecmdata[2]=l-3;
				if (ecmdata[0]==0x81) ecmdata[12]+= 1;
				}

			if (pcesacnt>0) for (j=0;j<pcesacnt;j++) 
				if (memcmp(cmd2,pcesacc[j].pces,18)==0) 
					{
					if (dbg) printf("Access-list Match. Routing to Card[%d]\n",pcesacc[j].kart);
					if (pcesacc[j].kart==-1) goto Defgo;
					nx=pcesacc[j].kart;
					goto ForwardECM;
					}
FindRoute:
			for (nx=0;nx<Ncnt;nx++)
				if ((Nlist[nx].active) && (Nlist[nx].caid==caidx))
					{
					for (m=0;m<Nlist[nx].prvcnt;m++)	
						if (Nlist[nx].provs[m]==provx)	break;
					if (Nlist[nx].provs[m]==provx)	break;
					}

			if (nx==Ncnt) {
				if (dbg) printf("No NCC forwaring required. No Provider.\n"); 
				goto Defgo;
				} 
			//check SID allowed or not.
			if (Nlist[nx].sidcnt>0)
				{
			   	for (j=0;j<Nlist[nx].sidcnt;j++)
					if (sidx==Nlist[nx].sids[j]) break;

				if (j==Nlist[nx].sidcnt)
					{
					if (dbg) printf("SID  is not Allowed.\n"); 
					goto Defgo;
					}  else if (dbg) printf("SID  is %04X. Allowed.\n",sidx); 
				}
			//check chid if irdeto
			if ( ((caidx & 0xff00)==0x0600) && (Nlist[nx].cidcnt>0) && (Nlist[nx].sidcnt>0))
				{
				irdchid= (ecmdata[6]<<8)+ecmdata[7];
				if (Nlist[nx].chid[j]!=irdchid)
					{
					if (dbg) printf("CHID is not Allowed.\n"); 
					goto Defgo;
					}
				}
ForwardECM:
			crcx=0;
			for (j=0;j<ecmlen;j++) crcx+=ecmdata[j];	//crc of ecm
			tidx=ecmdata[0];				//table id of ecm 80 / 81
			
			// start ncc processing
			pthread_mutex_lock( &nccmutex[nx]);
			if (!Ncc[nx]->is_ready())
				{
				Nlist[nx].active=false;
				pthread_mutex_unlock( &nccmutex[nx]);
				goto FindRoute;
				}
			//check in keysDB				
			pthread_mutex_lock( &keymutex );
			for (j=0;j<dbsize;j++)
				if (memcmp(cmd2,keysDB[j].pces,18)==0) break;
			dbcur=dbsize;
			if ( (j!=dbsize) && (dbsize>0) )	//means key found
				{
				dbcur=j;
				if ( (keysDB[j].ecmcrc==crcx) && (keysDB[j].ecmid==tidx) )
					{
					memset(echoBuffer,0,sizeof(echoBuffer));
					strcpy(echoBuffer,"KEY:"); 
					memcpy(echoBuffer+4,keysDB[j].keys,32);
					keyok=true;
					if (dbg) printf("KEY Found in Cache.    DBcur:%d\n",dbcur); 
					}
				}
			pthread_mutex_unlock( &keymutex );

			if ( (!keyok) && Ncc[nx]->is_ready() )
				{ 		
				Ncc[nx]->send_ecm(ecmdata,ecmlen,sidx);
				if (!Ncc[nx]->status) 
					{
					char 	mycw[3];
					memset(echoBuffer,0,sizeof(echoBuffer));
					strcpy(echoBuffer,"KEY:");
					for (j=0;j<8;j++) 
						{
						sprintf(mycw,"%02X",Ncc[nx]->cw_0[j]);
						strcat(echoBuffer,mycw);
						}
					for (j=0;j<8;j++) 
						{
						sprintf(mycw,"%02X",Ncc[nx]->cw_1[j]);
						strcat(echoBuffer,mycw);
						}
					keyok=true;	
					}
						
				if (keyok)    //key received from ecm..   insert to keysDB
					{
					pthread_mutex_lock( &keymutex );
					memcpy(keysDB[dbcur].pces,cmd2,18);
					memcpy(keysDB[dbcur].keys,echoBuffer+4,32);
					keysDB[dbcur].ecmcrc=crcx;
					keysDB[dbcur].ecmid=tidx;
					if (dbcur==dbsize) dbsize++;
					pthread_mutex_unlock( &keymutex );
					if  (dupcnt>0) for (j=0;j<dupcnt;j++) if (memcmp(cmd2,dupkeys[j].pces1,18)==0)
						{
						pthread_mutex_lock( &dcwmutex );
						memcpy(dcwlist[j].keys,echoBuffer+4,32);
						pthread_mutex_unlock( &dcwmutex );
						if (dbg) printf("DCW item[%d] Duplicated %s as  %s \n",j,cmd2,dcwlist[j].pces);
						}
					}
				}
			if (!Ncc[nx]->is_ready()) Nlist[nx].active=false;
			pthread_mutex_unlock( &nccmutex[nx] );
			}    //end of  ECM command
		Defgo:
		if  (!keyok)  strcpy(echoBuffer,"ASK:NOP\0");
		if (dbg) printf("Command  Response   : %s to %s\n",echoBuffer,cl_ip);
		recvMsgSize=strlen(echoBuffer);
		if ( recvMsgSize > 60 || recvMsgSize < 7 ) goto GEBER;
		if (gizli) 
			{
			btkcrypt(echoBuffer,recvMsgSize,keyIV);
			recvMsgSize += 2;
			}
		if (write(clntSock, echoBuffer, recvMsgSize) != recvMsgSize ) 
				{ 
				if (dbg) printf("Error in Write message : %d\n",recvMsgSize);
				goto GEBER;
				}
		if ((thrid!=srcuser->tid) && (srcuser->stat==1)) auth=false;
		}
	
	GEBER:
	shutdown(clntSock,2);    /* Close client socket */
	close (clntSock);
	if (dbg) printf("Client disconnected : %s\n",cl_ip);
	
	pthread_mutex_lock( &usrmutex );
	if (auth) srcuser->ok=false;
	conn--;
	pthread_mutex_unlock( &usrmutex );
		
	return (NULL);
}

/////////////////////////// Network Read Write ///////////////////////
int network_write(int fdesc,unsigned char *buffer, unsigned int length)
{
	//write with time-out
	struct pollfd pfd;
	int write_result;
	
	pfd.fd = fdesc;
	pfd.events = POLLOUT | POLLERR;
	pfd.revents = 0;
	
	if(poll(&pfd, 1, timeout) != 1) return -2;
	
	if(pfd.revents & POLLOUT)
	{
		write_result = write(fdesc, buffer, length);
		//debug_output(buffer, write_result, "e> ");
		return write_result;
	}
	else
		return -1; 
}

int network_read(int fdesc, unsigned char *buffer, unsigned int length)
{
	//read with time-out
	struct pollfd pfd;
	int read_result;
	
	pfd.fd = fdesc;
	pfd.events = POLLIN | POLLERR;
	pfd.revents = 0;
	
	if(poll(&pfd, 1, timeout) != 1) return -2;
	
	if(pfd.revents & POLLIN)
	{
		read_result = read(fdesc, buffer, length);
		//debug_output(buffer, read_result, "e< ");
		return read_result;
	}
	else
		return -1;
}

////////////////////////////////////////////////

void *ThreadUDP(void *threadArgs)
{
int  udptsock;
struct sockaddr_in udpClntAddr; /* Client address */
unsigned int cliAddrLen;         /* Length of incoming message */
char udpBuffer[255];        /* Buffer for echo string */
int recvMsgSize;                 /* Size of received message */
int ix,iz,iy;
int curdcw;

    /* Guarantees that thread resources are deallocated upon return */
    pthread_detach(pthread_self()); 

    /* Extract socket file descriptor from argument */
    udptsock = ((struct ThreadArgs *) threadArgs) -> clntSock;
    free(threadArgs);              /* Deallocate memory for argument */

    for (;;) /* Run forever */
    	{
        /* Set the size of the in-out parameter */
        cliAddrLen = sizeof(udpClntAddr);
	memset(udpBuffer,0,sizeof(udpBuffer));
        /* Block until receive message from a client */
        if ((recvMsgSize = recvfrom(udptsock, udpBuffer, 100, 0, (struct sockaddr *) &udpClntAddr, &cliAddrLen)) < 0)
            DieWithError("UDPthread recvfrom() failed");

	if ( (strlen(keyUDP)==6) && (memcmp(udpBuffer+51,keyUDP,6)!=0) )
		{	
		if (dbg) printf("Invalid KEY :%s\n",udpBuffer);	
		recvMsgSize=51;
		}

	if (recvMsgSize==57)
		{
		curdcw=-1;
		pthread_mutex_lock( &dcwmutex );
		//if (dupcnt==1) memcpy(dcwlist[0].keys,udpBuffer+18,32);
		for (ix=dupcnt;ix<dcwcnt;ix++)
			if (memcmp(udpBuffer,dcwlist[ix].pces,18)==0)
				{
				curdcw=ix; 
				break;
				}
		if (curdcw==-1) 
			{
			curdcw=dcwcnt;
			dcwcnt+=1;
			memcpy(dcwlist[curdcw].pces,udpBuffer,18);
			dcwlist[curdcw].pces[18]=0;
			dcwlist[curdcw].keys[32]=0;
			}
		memcpy(dcwlist[curdcw].keys,udpBuffer+18,32);
		if (dbg) printf("DCW Key Received %d: %s %s\n",curdcw,dcwlist[curdcw].pces,dcwlist[curdcw].keys);
		pthread_mutex_unlock( &dcwmutex );				//unlock mutex
		} //msgsize-50 if
    	} // for ever
    return (NULL);
}

void *ThreadTEL(void *)
{
int telcs;
sockaddr_in claddr;
socklen_t clen;
char cl_ip[20];
char telBuffer[255];        /* Buffer for telnet string */
int recvMsgSize;            /* Size of received message */
char tmps[100];
struct userlist *userl;

	pthread_detach(pthread_self()); 
	telsock = CreateTCPServerSocket(telport);

telstart:	
	telcs = AcceptTCPConnection(telsock);
	clen = sizeof(claddr);
	getpeername(telcs, (sockaddr*)&claddr, &clen);
	strcpy(cl_ip,inet_ntoa(claddr.sin_addr));
	if (dbg) printf("Telnet Connection From     : %s\n",cl_ip);
	//send welcome message and start loop
	memset(telBuffer,0,sizeof(telBuffer));
	strcpy(telBuffer,"Welcome to DCWTelnet Server by BillyTK\r\nPass:\0");
	if (write(telcs, telBuffer, 45) != 45)  goto telend;
	/* Receive message from client for authtenication*/
	memset(telBuffer,0,sizeof(telBuffer));
	recvMsgSize = read(telcs, telBuffer, 250);	
	if (memcmp(keyTEL,telBuffer,strlen(keyTEL))) goto telend;
	memset(telBuffer,0,sizeof(telBuffer));
	strcpy(telBuffer,"Commands : total - users - exit \r\n\0");
	if (write(telcs, telBuffer, strlen(telBuffer)) != (strlen(telBuffer)))  goto telend;
	while (1)
		{
		strcpy(telBuffer,"\r\nCMD : \0");
		if (write(telcs, telBuffer, strlen(telBuffer)) != (strlen(telBuffer)))  goto telend;
		recvMsgSize = read(telcs, telBuffer, 250);
		if (recvMsgSize<4) goto telend;
		if (memcmp(telBuffer,"exit",4)==0) goto telend;
		if (memcmp(telBuffer,"total",5)==0)
			{
			memset(telBuffer,0,sizeof(telBuffer));
			strcpy(telBuffer,"Total user count : "); sprintf(tmps,"%d",conn); strcat(telBuffer,tmps); strcat(telBuffer,"\r\n\0");
			if (write(telcs, telBuffer, strlen(telBuffer)) != (strlen(telBuffer)))  goto telend;
			}
		if (memcmp(telBuffer,"users",5)==0)
			{
			strcpy(telBuffer,"Username              Password              St  Ip Address    Act \r\n\0");
			if (write(telcs, telBuffer, strlen(telBuffer)) != (strlen(telBuffer)))  goto telend;
			memset(telBuffer,32,200);
			pthread_mutex_lock( &usrmutex );
			userl=users;
			while (userl!=NULL)
				{
				memcpy(telBuffer,userl->user,strlen(userl->user));
				memcpy(telBuffer+22,userl->pass,strlen(userl->pass));
				memset(telBuffer+45,48+userl->stat,1);
				memcpy(telBuffer+48,userl->ip,strlen(userl->ip));
				memset(telBuffer+63,userl->ok+48,1);
				memset(telBuffer+65,10,1);memset(telBuffer+66,13,1);memset(telBuffer+67,0,1);
				if (write(telcs, telBuffer, strlen(telBuffer)) != (strlen(telBuffer)))  goto telend;
				userl=userl->next;
				}
			pthread_mutex_unlock( &usrmutex );
			}
		}

telend:
	shutdown(telcs,2);    /* Close client socket */
	close (telcs);
	if (dbg) printf("Telnet Client disconnected : %s\n",cl_ip);
	goto telstart;

	return (NULL);
}

void *Srv_status(void * )
{
int x,i,kart;
int loop;

pthread_detach(pthread_self()); 
loop=0;
while (1)
	{
	sleep(10);
	pthread_mutex_lock( &usrmutex );
	//printf("Total user count : %d\n",conn);
	pthread_mutex_unlock( &usrmutex );
	for (x=0;x<Ncnt;x++) 
	   if ((!Nlist[x].active) && (Nlist[x].prvcnt>0) )
		{
		pthread_mutex_lock( &nccmutex[x] );
		delete(Ncc[x]);
		printf("------------INIT NCC %d ------------------------------\n",x);
		if (Ncc[x] = new newcamd_client(Nlist[x].confn,timeout,VERSION_525), !Ncc[x])
			{
			perror("NEWCAMD Server #%d  Init Failed ");
			return(0);
			}
		Ncc[x]->dbg=dbg;
		Nlist[x].active=Ncc[x]->is_ready();
		pthread_mutex_unlock( &nccmutex[x] );
		}
	}

return (NULL);
}

